<template>
  <section ref="parent">
    <h1>Shapes</h1>

    <p v-if="shape">
      <label>
        <button @click="toggleShape">{{ shape }}</button>
      </label>

      <label>
        color:
        <input
          :value="colors[shape]"
          type="color"
          @change="setColor($event.target.value)"
        />
      </label>
    </p>

    <p v-else>Loading…</p>
  </section>
</template>

<script>
import { createNamespacedHelpers } from 'vuex'
import Game from '~/lib/game'
import CircleScene from '~/lib/circle-scene'
import RectangleScene from '~/lib/rectangle-scene'

const { mapMutations, mapState } = createNamespacedHelpers('shapes')

export default {
  computed: {
    ...mapState(['colors', 'shape'])
  },

  watch: {
    colors: {
      handler(newColor) {
        const scene = this.scenes[this.shape]
        scene.setColor(newColor[this.shape])
      },
      deep: true
    },

    shape(newValue) {
      Object.entries(this.scenes).forEach(([key, scene]) => {
        if (key !== newValue) {
          scene.scene.stop()
        }
      })

      const newScene = this.scenes[newValue]
      newScene.events.once('update', () => {
        newScene.setColor(this.colors[newValue])
      })
      newScene.scene.start()
    }
  },

  mounted() {
    const { parent } = this.$refs
    this.game = new Game({
      parent,
      width: 200,
      height: 200
    })

    this.scenes = {
      circle: new CircleScene(),
      rectangle: new RectangleScene()
    }

    Object.entries(this.scenes).forEach(([key, scene]) => {
      this.game.scene.add(key, scene)
    })

    this.game.events.on('ready', this.toggleShape)
  },

  methods: {
    ...mapMutations(['setColor', 'toggleShape'])
  }
}
</script>
